jQuery(document).ready( function($) {

	var $tb = $('#wpadminbar'),
		$tbh = $tb.height();

	$tb.css( 'top', ($tbh*-1) );

	$tb.hover( function() {
		$tb.addClass('hovering');
	}, function() {
		$tb.removeClass('hovering');
	});

	$('body').mousemove( function( ev ) {

		$tbp = parseInt($tb.css('top'));

		if ( ev.clientY <= $tbh && $tbp < 0 && !$tb.hasClass('sliding') ) {
			// cursor in zone and bar is hidden and is not currently sliding
			$tb.addClass('sliding').animate({
				'top': 0
			}, 100, function() {
				$tb.removeClass('sliding');
			});
		}
		else if ( ev.clientY > $tbh && $tbp == 0 && ! $tb.hasClass('hovering') ) {
			// cursor not in zone and bar is showing and not in submenu
			$tb.stop().animate({
				'top': ($tbh*-1)
			}, 50, function() {
				$tb.removeClass('sliding');
			});
		}
		else if ( ( ev.clientY <= $tbh && $tbp == 0 ) || ( ev.clientY > $tbh && $tbp < 0 ) ) {
			// cursor in zone and bar is showing
			// or, not in zone and bar is hidden
			// do nothing!
		}
	});

});